import _debounce from "lodash/debounce";(function () {var enterModule = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.enterModule : undefined;enterModule && enterModule(module);})();var __signature__ = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.default.signature : function (a) {return a;}; /**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
import { useEffect, useRef, useState } from 'react';


export const useOverflowDetection = (flexGap) => {
  const symbolContainerRef = useRef(null);
  const wrapperRef = useRef(null);
  const [isOverflowing, setIsOverflowing] = useState(false);

  useEffect(() => {
    let obs;
    const symbolContainerElem = symbolContainerRef.current;
    const wrapperElem = wrapperRef.current;
    if (symbolContainerElem && wrapperElem) {
      const symbolContainerChildrenElems = Array.from(
        symbolContainerElem.children
      );
      obs = new ResizeObserver(
        _debounce(() => {
          const totalChildrenWidth = symbolContainerChildrenElems.reduce(
            (acc, element) => {var _element$firstElement, _element$firstElement2;return (
                // take symbol container's child's scroll width to account for the container growing with display: flex
                acc + ((_element$firstElement = (_element$firstElement2 = element.firstElementChild) == null ? void 0 : _element$firstElement2.scrollWidth) != null ? _element$firstElement : 0));},
            0
          );
          if (
          totalChildrenWidth +
          flexGap * Math.max(symbolContainerChildrenElems.length - 1, 0) >
          wrapperElem.clientWidth)
          {
            setIsOverflowing(true);
          } else {
            setIsOverflowing(false);
          }
        }, 500)
      );
      obs.observe(document.body);
      symbolContainerChildrenElems.forEach((elem) => {
        obs.observe(elem);
      });
    }
    return () => {var _obs;return (_obs = obs) == null ? void 0 : _obs.disconnect();};
  }, [flexGap]);

  return { isOverflowing, symbolContainerRef, wrapperRef };
};__signature__(useOverflowDetection, "useRef{symbolContainerRef}\nuseRef{wrapperRef}\nuseState{[isOverflowing, setIsOverflowing](false)}\nuseEffect{}");;(function () {var reactHotLoader = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.default : undefined;if (!reactHotLoader) {return;}reactHotLoader.register(useOverflowDetection, "useOverflowDetection", "/Users/evan_1/GitHub/superset/superset-frontend/plugins/plugin-chart-echarts/src/BigNumber/BigNumberPeriodOverPeriod/useOverflowDetection.ts");})();;(function () {var leaveModule = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.leaveModule : undefined;leaveModule && leaveModule(module);})();
//# sourceMappingURL=useOverflowDetection.js.map