import _invert from "lodash/invert"; /**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
/* eslint-disable camelcase */(function () {var enterModule = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.enterModule : undefined;enterModule && enterModule(module);})();var __signature__ = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.default.signature : function (a) {return a;};

import {

  AxisType,
  buildCustomFormatters,
  CategoricalColorNamespace,
  CurrencyFormatter,
  ensureIsArray,
  GenericDataType,
  getCustomFormatter,
  getNumberFormatter,
  getXAxisLabel,
  isDefined,
  isEventAnnotationLayer,
  isFormulaAnnotationLayer,
  isIntervalAnnotationLayer,
  isPhysicalColumn,
  isTimeseriesAnnotationLayer,




  tooltipHtml } from

'@superset-ui/core';
import { getOriginalSeries } from '@superset-ui/chart-controls';


import {
  DEFAULT_FORM_DATA } from



'./types';
import {
  EchartsTimeseriesSeriesType,
  ForecastSeriesEnum } from

'../types';
import { parseAxisBound } from '../utils/controls';
import {
  dedupSeries,
  extractDataTotalValues,
  extractSeries,
  extractShowValueIndexes,
  getAxisType,
  getColtypesMapping,
  getLegendProps,
  getMinAndMaxFromBounds,
  getOverMaxHiddenFormatter } from
'../utils/series';
import {
  extractAnnotationLabels,
  getAnnotationData } from
'../utils/annotation';
import {
  extractForecastSeriesContext,
  extractForecastValuesFromTooltipParams,
  formatForecastTooltipSeries,
  rebaseForecastDatum } from
'../utils/forecast';
import { convertInteger } from '../utils/convertInteger';
import { defaultGrid, defaultYAxis } from '../defaults';
import {
  getPadding,
  transformEventAnnotation,
  transformFormulaAnnotation,
  transformIntervalAnnotation,
  transformSeries,
  transformTimeseriesAnnotation } from
'../Timeseries/transformers';
import { TIMEGRAIN_TO_TIMESTAMP, TIMESERIES_CONSTANTS } from '../constants';
import { getDefaultTooltip } from '../utils/tooltip';
import {
  getTooltipTimeFormatter,
  getXAxisFormatter,
  getYAxisFormatter } from
'../utils/formatters';

const getFormatter = (
customFormatters,
defaultFormatter,
metrics,
formatterKey,
forcePercentFormat) =>
{var _getCustomFormatter;
  if (forcePercentFormat) {
    return getNumberFormatter(',.0%');
  }
  return (_getCustomFormatter =
  getCustomFormatter(customFormatters, metrics, formatterKey)) != null ? _getCustomFormatter :
  defaultFormatter;

};

export default function transformProps(
chartProps)
{var _chartProps$rawFormDa, _dataTypes$xAxisLabel, _chartProps$rawFormDa2;
  const {
    width,
    height,
    formData,
    queriesData,
    hooks,
    filterState,
    datasource,
    theme,
    inContextMenu,
    emitCrossFilters
  } = chartProps;

  let focusedSeries = null;

  const {
    verboseMap = {},
    currencyFormats = {},
    columnFormats = {}
  } = datasource;
  const { label_map: labelMap } =
  queriesData[0];
  const { label_map: labelMapB } =
  queriesData[1];
  const data1 = queriesData[0].data || [];
  const data2 = queriesData[1].data || [];
  const annotationData = getAnnotationData(chartProps);
  const coltypeMapping = {
    ...getColtypesMapping(queriesData[0]),
    ...getColtypesMapping(queriesData[1])
  };
  const {
    area,
    areaB,
    annotationLayers,
    colorScheme,
    contributionMode,
    legendOrientation,
    legendType,
    logAxis,
    logAxisSecondary,
    markerEnabled,
    markerEnabledB,
    markerSize,
    markerSizeB,
    opacity,
    opacityB,
    minorSplitLine,
    minorTicks,
    seriesType,
    seriesTypeB,
    showLegend,
    showValue,
    showValueB,
    stack,
    stackB,
    truncateXAxis,
    truncateYAxis,
    tooltipTimeFormat,
    yAxisFormat,
    currencyFormat,
    yAxisFormatSecondary,
    currencyFormatSecondary,
    xAxisTimeFormat,
    yAxisBounds,
    yAxisBoundsSecondary,
    yAxisIndex,
    yAxisIndexB,
    yAxisTitleSecondary,
    zoomable,
    richTooltip,
    tooltipSortByMetric,
    xAxisBounds,
    xAxisLabelRotation,
    groupby,
    groupbyB,
    xAxis: xAxisOrig,
    xAxisForceCategorical,
    xAxisTitle,
    yAxisTitle,
    xAxisTitleMargin,
    yAxisTitleMargin,
    yAxisTitlePosition,
    sliceId,
    timeGrainSqla,
    percentageThreshold,
    metrics = [],
    metricsB = []
  } = { ...DEFAULT_FORM_DATA, ...formData };

  const refs = {};
  const colorScale = CategoricalColorNamespace.getScale(colorScheme);

  let xAxisLabel = getXAxisLabel(
    chartProps.rawFormData
  );
  if (
  isPhysicalColumn((_chartProps$rawFormDa = chartProps.rawFormData) == null ? void 0 : _chartProps$rawFormDa.x_axis) &&
  isDefined(verboseMap[xAxisLabel]))
  {
    xAxisLabel = verboseMap[xAxisLabel];
  }

  const rebasedDataA = rebaseForecastDatum(data1, verboseMap);
  const [rawSeriesA] = extractSeries(rebasedDataA, {
    fillNeighborValue: stack ? 0 : undefined,
    xAxis: xAxisLabel
  });
  const rebasedDataB = rebaseForecastDatum(data2, verboseMap);
  const [rawSeriesB] = extractSeries(rebasedDataB, {
    fillNeighborValue: stackB ? 0 : undefined,
    xAxis: xAxisLabel
  });

  const dataTypes = getColtypesMapping(queriesData[0]);
  const xAxisDataType = (_dataTypes$xAxisLabel = dataTypes == null ? void 0 : dataTypes[xAxisLabel]) != null ? _dataTypes$xAxisLabel : dataTypes == null ? void 0 : dataTypes[xAxisOrig];
  const xAxisType = getAxisType(stack, xAxisForceCategorical, xAxisDataType);
  const series = [];
  const formatter = contributionMode ?
  getNumberFormatter(',.0%') :
  currencyFormat != null && currencyFormat.symbol ?
  new CurrencyFormatter({
    d3Format: yAxisFormat,
    currency: currencyFormat
  }) :
  getNumberFormatter(yAxisFormat);
  const formatterSecondary = contributionMode ?
  getNumberFormatter(',.0%') :
  currencyFormatSecondary != null && currencyFormatSecondary.symbol ?
  new CurrencyFormatter({
    d3Format: yAxisFormatSecondary,
    currency: currencyFormatSecondary
  }) :
  getNumberFormatter(yAxisFormatSecondary);
  const customFormatters = buildCustomFormatters(
    [...ensureIsArray(metrics), ...ensureIsArray(metricsB)],
    currencyFormats,
    columnFormats,
    yAxisFormat,
    currencyFormat
  );
  const customFormattersSecondary = buildCustomFormatters(
    [...ensureIsArray(metrics), ...ensureIsArray(metricsB)],
    currencyFormats,
    columnFormats,
    yAxisFormatSecondary,
    currencyFormatSecondary
  );

  const primarySeries = new Set();
  const secondarySeries = new Set();
  const mapSeriesIdToAxis = (
  seriesOption,
  index) =>
  {
    if (index === 1) {
      secondarySeries.add(seriesOption.id);
    } else {
      primarySeries.add(seriesOption.id);
    }
  };
  rawSeriesA.forEach((seriesOption) =>
  mapSeriesIdToAxis(seriesOption, yAxisIndex)
  );
  rawSeriesB.forEach((seriesOption) =>
  mapSeriesIdToAxis(seriesOption, yAxisIndexB)
  );
  const showValueIndexesA = extractShowValueIndexes(rawSeriesA, {
    stack
  });
  const showValueIndexesB = extractShowValueIndexes(rawSeriesB, {
    stack
  });
  const { totalStackedValues, thresholdValues } = extractDataTotalValues(
    rebasedDataA,
    {
      stack,
      percentageThreshold,
      xAxisCol: xAxisLabel
    }
  );
  const {
    totalStackedValues: totalStackedValuesB,
    thresholdValues: thresholdValuesB
  } = extractDataTotalValues(rebasedDataB, {
    stack: Boolean(stackB),
    percentageThreshold,
    xAxisCol: xAxisLabel
  });

  annotationLayers.
  filter((layer) => layer.show).
  forEach((layer) => {
    if (isFormulaAnnotationLayer(layer))
    series.push(
      transformFormulaAnnotation(
        layer,
        data1,
        xAxisLabel,
        xAxisType,
        colorScale,
        sliceId
      )
    );else
    if (isIntervalAnnotationLayer(layer)) {
      series.push(
        ...transformIntervalAnnotation(
          layer,
          data1,
          annotationData,
          colorScale,
          theme,
          sliceId
        )
      );
    } else if (isEventAnnotationLayer(layer)) {
      series.push(
        ...transformEventAnnotation(
          layer,
          data1,
          annotationData,
          colorScale,
          theme,
          sliceId
        )
      );
    } else if (isTimeseriesAnnotationLayer(layer)) {
      series.push(
        ...transformTimeseriesAnnotation(
          layer,
          markerSize,
          data1,
          annotationData,
          colorScale,
          sliceId
        )
      );
    }
  });

  // yAxisBounds need to be parsed to replace incompatible values with undefined
  const [xAxisMin, xAxisMax] = (xAxisBounds || []).map(parseAxisBound);
  let [yAxisMin, yAxisMax] = (yAxisBounds || []).map(parseAxisBound);
  let [minSecondary, maxSecondary] = (yAxisBoundsSecondary || []).map(
    parseAxisBound
  );

  const array = ensureIsArray((_chartProps$rawFormDa2 = chartProps.rawFormData) == null ? void 0 : _chartProps$rawFormDa2.time_compare);
  const inverted = _invert(verboseMap);

  rawSeriesA.forEach((entry) => {var _labelMap$seriesName;
    const entryName = String(entry.name || '');
    const seriesName = inverted[entryName] || entryName;
    const colorScaleKey = getOriginalSeries(seriesName, array);

    const seriesFormatter = getFormatter(
      customFormatters,
      formatter,
      metrics,
      labelMap == null ? void 0 : (_labelMap$seriesName = labelMap[seriesName]) == null ? void 0 : _labelMap$seriesName[0],
      !!contributionMode
    );

    const transformedSeries = transformSeries(
      entry,
      colorScale,
      colorScaleKey,
      {
        area,
        markerEnabled,
        markerSize,
        areaOpacity: opacity,
        seriesType,
        showValue,
        stack: Boolean(stack),
        stackIdSuffix: '\na',
        yAxisIndex,
        filterState,
        seriesKey: entry.name,
        sliceId,
        queryIndex: 0,
        formatter:
        seriesType === EchartsTimeseriesSeriesType.Bar ?
        getOverMaxHiddenFormatter({
          max: yAxisMax,
          formatter: seriesFormatter
        }) :
        seriesFormatter,
        showValueIndexes: showValueIndexesA,
        totalStackedValues,
        thresholdValues
      }
    );
    if (transformedSeries) series.push(transformedSeries);
  });

  rawSeriesB.forEach((entry) => {var _labelMapB$seriesName;
    const entryName = String(entry.name || '');
    const seriesEntry = inverted[entryName] || entryName;
    const seriesName = `${seriesEntry} (1)`;
    const colorScaleKey = getOriginalSeries(seriesEntry, array);

    const seriesFormatter = getFormatter(
      customFormattersSecondary,
      formatterSecondary,
      metricsB,
      labelMapB == null ? void 0 : (_labelMapB$seriesName = labelMapB[seriesName]) == null ? void 0 : _labelMapB$seriesName[0],
      !!contributionMode
    );

    const transformedSeries = transformSeries(
      entry,
      colorScale,
      colorScaleKey,
      {
        area: areaB,
        markerEnabled: markerEnabledB,
        markerSize: markerSizeB,
        areaOpacity: opacityB,
        seriesType: seriesTypeB,
        showValue: showValueB,
        stack: Boolean(stackB),
        stackIdSuffix: '\nb',
        yAxisIndex: yAxisIndexB,
        filterState,
        seriesKey: primarySeries.has(entry.name) ?
        `${entry.name} (1)` :
        entry.name,
        sliceId,
        queryIndex: 1,
        formatter:
        seriesTypeB === EchartsTimeseriesSeriesType.Bar ?
        getOverMaxHiddenFormatter({
          max: maxSecondary,
          formatter: seriesFormatter
        }) :
        seriesFormatter,
        showValueIndexes: showValueIndexesB,
        totalStackedValues: totalStackedValuesB,
        thresholdValues: thresholdValuesB
      }
    );
    if (transformedSeries) series.push(transformedSeries);
  });

  // default to 0-100% range when doing row-level contribution chart
  if (contributionMode === 'row' && stack) {
    if (yAxisMin === undefined) yAxisMin = 0;
    if (yAxisMax === undefined) yAxisMax = 1;
    if (minSecondary === undefined) minSecondary = 0;
    if (maxSecondary === undefined) maxSecondary = 1;
  }

  const tooltipFormatter =
  xAxisDataType === GenericDataType.Temporal ?
  getTooltipTimeFormatter(tooltipTimeFormat) :
  String;
  const xAxisFormatter =
  xAxisDataType === GenericDataType.Temporal ?
  getXAxisFormatter(xAxisTimeFormat) :
  String;

  const addYAxisTitleOffset = !!(yAxisTitle || yAxisTitleSecondary);
  const addXAxisTitleOffset = !!xAxisTitle;

  const chartPadding = getPadding(
    showLegend,
    legendOrientation,
    addYAxisTitleOffset,
    zoomable,
    null,
    addXAxisTitleOffset,
    yAxisTitlePosition,
    convertInteger(yAxisTitleMargin),
    convertInteger(xAxisTitleMargin)
  );

  const { setDataMask = () => {}, onContextMenu } = hooks;
  const alignTicks = yAxisIndex !== yAxisIndexB;

  const echartOptions = {
    useUTC: true,
    grid: {
      ...defaultGrid,
      ...chartPadding
    },
    xAxis: {
      type: xAxisType,
      name: xAxisTitle,
      nameGap: convertInteger(xAxisTitleMargin),
      nameLocation: 'middle',
      axisLabel: {
        formatter: xAxisFormatter,
        rotate: xAxisLabelRotation
      },
      minorTick: { show: minorTicks },
      minInterval:
      xAxisType === AxisType.Time && timeGrainSqla ?
      TIMEGRAIN_TO_TIMESTAMP[timeGrainSqla] :
      0,
      ...getMinAndMaxFromBounds(
        xAxisType,
        truncateXAxis,
        xAxisMin,
        xAxisMax,
        seriesType === EchartsTimeseriesSeriesType.Bar ||
        seriesTypeB === EchartsTimeseriesSeriesType.Bar ?
        EchartsTimeseriesSeriesType.Bar :
        undefined
      )
    },
    yAxis: [
    {
      ...defaultYAxis,
      type: logAxis ? 'log' : 'value',
      min: yAxisMin,
      max: yAxisMax,
      minorTick: { show: minorTicks },
      minorSplitLine: { show: minorSplitLine },
      axisLabel: {
        formatter: getYAxisFormatter(
          metrics,
          !!contributionMode,
          customFormatters,
          formatter,
          yAxisFormat
        )
      },
      scale: truncateYAxis,
      name: yAxisTitle,
      nameGap: convertInteger(yAxisTitleMargin),
      nameLocation: yAxisTitlePosition === 'Left' ? 'middle' : 'end',
      alignTicks
    },
    {
      ...defaultYAxis,
      type: logAxisSecondary ? 'log' : 'value',
      min: minSecondary,
      max: maxSecondary,
      minorTick: { show: minorTicks },
      splitLine: { show: false },
      minorSplitLine: { show: minorSplitLine },
      axisLabel: {
        formatter: getYAxisFormatter(
          metricsB,
          !!contributionMode,
          customFormattersSecondary,
          formatterSecondary,
          yAxisFormatSecondary
        )
      },
      scale: truncateYAxis,
      name: yAxisTitleSecondary,
      alignTicks
    }],

    tooltip: {
      ...getDefaultTooltip(refs),
      show: !inContextMenu,
      trigger: richTooltip ? 'axis' : 'item',
      formatter: (params) => {
        const xValue = richTooltip ?
        params[0].value[0] :
        params.value[0];
        const forecastValue = richTooltip ? params : [params];

        if (richTooltip && tooltipSortByMetric) {
          forecastValue.sort((a, b) => b.data[1] - a.data[1]);
        }

        const rows = [];
        const forecastValues =
        extractForecastValuesFromTooltipParams(forecastValue);

        const keys = Object.keys(forecastValues);
        keys.forEach((key) => {
          const value = forecastValues[key];
          // if there are no dimensions, key is a verbose name of a metric,
          // otherwise it is a comma separated string where the first part is metric name
          let formatterKey;
          if (primarySeries.has(key)) {var _labelMap$key;
            formatterKey =
            groupby.length === 0 ? inverted[key] : (_labelMap$key = labelMap[key]) == null ? void 0 : _labelMap$key[0];
          } else {var _labelMapB$key;
            formatterKey =
            groupbyB.length === 0 ? inverted[key] : (_labelMapB$key = labelMapB[key]) == null ? void 0 : _labelMapB$key[0];
          }
          const tooltipFormatter = getFormatter(
            customFormatters,
            formatter,
            metrics,
            formatterKey,
            !!contributionMode
          );
          const tooltipFormatterSecondary = getFormatter(
            customFormattersSecondary,
            formatterSecondary,
            metricsB,
            formatterKey,
            !!contributionMode
          );
          const row = formatForecastTooltipSeries({
            ...value,
            seriesName: key,
            formatter: primarySeries.has(key) ?
            tooltipFormatter :
            tooltipFormatterSecondary
          });
          rows.push(row);
        });
        return tooltipHtml(
          rows,
          tooltipFormatter(xValue),
          keys.findIndex((key) => key === focusedSeries)
        );
      }
    },
    legend: {
      ...getLegendProps(
        legendType,
        legendOrientation,
        showLegend,
        theme,
        zoomable
      ),
      // @ts-ignore
      data: rawSeriesA.
      concat(rawSeriesB).
      filter(
        (entry) =>
        extractForecastSeriesContext(entry.name || '').type ===
        ForecastSeriesEnum.Observation
      ).
      map((entry) => entry.name || '').
      concat(extractAnnotationLabels(annotationLayers, annotationData))
    },
    series: dedupSeries(series),
    toolbox: {
      show: zoomable,
      top: TIMESERIES_CONSTANTS.toolboxTop,
      right: TIMESERIES_CONSTANTS.toolboxRight,
      feature: {
        dataZoom: {
          yAxisIndex: false,
          title: {
            zoom: 'zoom area',
            back: 'restore zoom'
          }
        }
      }
    },
    dataZoom: zoomable ?
    [
    {
      type: 'slider',
      start: TIMESERIES_CONSTANTS.dataZoomStart,
      end: TIMESERIES_CONSTANTS.dataZoomEnd,
      bottom: TIMESERIES_CONSTANTS.zoomBottom
    }] :

    []
  };

  const onFocusedSeries = (seriesName) => {
    focusedSeries = seriesName;
  };

  return {
    formData,
    width,
    height,
    echartOptions,
    setDataMask,
    emitCrossFilters,
    labelMap,
    labelMapB,
    groupby,
    groupbyB,
    seriesBreakdown: rawSeriesA.length,
    selectedValues: filterState.selectedValues || [],
    onContextMenu,
    onFocusedSeries,
    xValueFormatter: tooltipFormatter,
    xAxis: {
      label: xAxisLabel,
      type: xAxisType
    },
    refs,
    coltypeMapping
  };
};(function () {var reactHotLoader = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.default : undefined;if (!reactHotLoader) {return;}reactHotLoader.register(getFormatter, "getFormatter", "/Users/evan_1/GitHub/superset/superset-frontend/plugins/plugin-chart-echarts/src/MixedTimeseries/transformProps.ts");reactHotLoader.register(transformProps, "transformProps", "/Users/evan_1/GitHub/superset/superset-frontend/plugins/plugin-chart-echarts/src/MixedTimeseries/transformProps.ts");})();;(function () {var leaveModule = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.leaveModule : undefined;leaveModule && leaveModule(module);})();
//# sourceMappingURL=transformProps.js.map