(function () {var enterModule = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.enterModule : undefined;enterModule && enterModule(module);})();var __signature__ = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.default.signature : function (a) {return a;}; /**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */

import { t, TimeGranularity } from '@superset-ui/core';

import {
  LabelPositionEnum,

  LegendOrientation,
  LegendType } from

'./types';

// eslint-disable-next-line import/prefer-default-export
export const NULL_STRING = '<NULL>';

export const TIMESERIES_CONSTANTS = {
  gridOffsetRight: 20,
  gridOffsetLeft: 20,
  gridOffsetTop: 20,
  gridOffsetBottom: 20,
  gridOffsetBottomZoomable: 80,
  legendRightTopOffset: 30,
  legendTopRightOffset: 55,
  zoomBottom: 30,
  toolboxTop: 0,
  toolboxRight: 5,
  dataZoomStart: 0,
  dataZoomEnd: 100,
  yAxisLabelTopOffset: 20,
  extraControlsOffset: 22
};

export const LABEL_POSITION = [
[LabelPositionEnum.Top, 'Top'],
[LabelPositionEnum.Left, 'Left'],
[LabelPositionEnum.Right, 'Right'],
[LabelPositionEnum.Bottom, 'Bottom'],
[LabelPositionEnum.Inside, 'Inside'],
[LabelPositionEnum.InsideBottomLeft, 'Inside left'],
[LabelPositionEnum.InsideBottomRight, 'Inside right'],
[LabelPositionEnum.InsideTop, 'Inside top'],
[LabelPositionEnum.InsideBottom, 'Inside bottom'],
[LabelPositionEnum.InsideTopLeft, 'Inside top left'],
[LabelPositionEnum.InsideBottomLeft, 'Inside bottom left'],
[LabelPositionEnum.InsideTopRight, 'Inside top right'],
[LabelPositionEnum.InsideBottomRight, 'Inside bottom right']];


export let OpacityEnum = /*#__PURE__*/function (OpacityEnum) {OpacityEnum[OpacityEnum["Transparent"] = 0] = "Transparent";OpacityEnum[OpacityEnum["SemiTransparent"] = 0.3] = "SemiTransparent";OpacityEnum[OpacityEnum["NonTransparent"] = 1] = "NonTransparent";return OpacityEnum;}({});





export let StackControlsValue = /*#__PURE__*/function (StackControlsValue) {StackControlsValue["Stack"] = "Stack";StackControlsValue["Stream"] = "Stream";StackControlsValue["Expand"] = "Expand";return StackControlsValue;}({});





export const StackControlOptions =


[
[null, t('None')],
[StackControlsValue.Stack, t('Stack')],
[StackControlsValue.Stream, t('Stream')]];


export const AreaChartStackControlOptions =


[...StackControlOptions, [StackControlsValue.Expand, t('Expand')]];

export const TIMEGRAIN_TO_TIMESTAMP = {
  [TimeGranularity.HOUR]: 3600 * 1000,
  [TimeGranularity.DAY]: 3600 * 1000 * 24,
  [TimeGranularity.MONTH]: 3600 * 1000 * 24 * 31,
  [TimeGranularity.QUARTER]: 3600 * 1000 * 24 * 31 * 3,
  [TimeGranularity.YEAR]: 3600 * 1000 * 24 * 31 * 12
};

export const DEFAULT_LEGEND_FORM_DATA = {
  legendMargin: null,
  legendOrientation: LegendOrientation.Top,
  legendType: LegendType.Scroll,
  showLegend: true
};

export const DEFAULT_TITLE_FORM_DATA = {
  xAxisTitle: '',
  xAxisTitleMargin: 0,
  yAxisTitle: '',
  yAxisTitleMargin: 0,
  yAxisTitlePosition: 'Top'
};

export { DEFAULT_FORM_DATA } from './Timeseries/constants';

// How far away from the mouse should the tooltip be
export const TOOLTIP_POINTER_MARGIN = 10;

// If no satisfactory position can be found, how far away
// from the edge of the window should the tooltip be kept
export const TOOLTIP_OVERFLOW_MARGIN = 5;;(function () {var reactHotLoader = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.default : undefined;if (!reactHotLoader) {return;}reactHotLoader.register(NULL_STRING, "NULL_STRING", "/Users/evan_1/GitHub/superset/superset-frontend/plugins/plugin-chart-echarts/src/constants.ts");reactHotLoader.register(TIMESERIES_CONSTANTS, "TIMESERIES_CONSTANTS", "/Users/evan_1/GitHub/superset/superset-frontend/plugins/plugin-chart-echarts/src/constants.ts");reactHotLoader.register(LABEL_POSITION, "LABEL_POSITION", "/Users/evan_1/GitHub/superset/superset-frontend/plugins/plugin-chart-echarts/src/constants.ts");reactHotLoader.register(StackControlOptions, "StackControlOptions", "/Users/evan_1/GitHub/superset/superset-frontend/plugins/plugin-chart-echarts/src/constants.ts");reactHotLoader.register(AreaChartStackControlOptions, "AreaChartStackControlOptions", "/Users/evan_1/GitHub/superset/superset-frontend/plugins/plugin-chart-echarts/src/constants.ts");reactHotLoader.register(TIMEGRAIN_TO_TIMESTAMP, "TIMEGRAIN_TO_TIMESTAMP", "/Users/evan_1/GitHub/superset/superset-frontend/plugins/plugin-chart-echarts/src/constants.ts");reactHotLoader.register(DEFAULT_LEGEND_FORM_DATA, "DEFAULT_LEGEND_FORM_DATA", "/Users/evan_1/GitHub/superset/superset-frontend/plugins/plugin-chart-echarts/src/constants.ts");reactHotLoader.register(DEFAULT_TITLE_FORM_DATA, "DEFAULT_TITLE_FORM_DATA", "/Users/evan_1/GitHub/superset/superset-frontend/plugins/plugin-chart-echarts/src/constants.ts");reactHotLoader.register(TOOLTIP_POINTER_MARGIN, "TOOLTIP_POINTER_MARGIN", "/Users/evan_1/GitHub/superset/superset-frontend/plugins/plugin-chart-echarts/src/constants.ts");reactHotLoader.register(TOOLTIP_OVERFLOW_MARGIN, "TOOLTIP_OVERFLOW_MARGIN", "/Users/evan_1/GitHub/superset/superset-frontend/plugins/plugin-chart-echarts/src/constants.ts");})();;(function () {var leaveModule = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.leaveModule : undefined;leaveModule && leaveModule(module);})();
//# sourceMappingURL=constants.js.map