import _transform from "lodash/transform";import _isNumber from "lodash/isNumber";import _groupBy2 from "lodash/groupBy"; /**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */(function () {var enterModule = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.enterModule : undefined;enterModule && enterModule(module);})();var __signature__ = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.default.signature : function (a) {return a;};











function getMetricValue(datum, metric) {
  return _isNumber(datum[metric]) ? datum[metric] : 0;
}

export function treeBuilder(
data,
groupBy,
metric,
secondaryMetric)
{
  const [curGroupBy, ...restGroupby] = groupBy;
  const curData = _groupBy2(data, curGroupBy);
  return _transform(
    curData,
    (result, value, key) => {
      const name = curData[key][0][curGroupBy];
      if (!restGroupby.length) {
        (value != null ? value : []).forEach((datum) => {
          const metricValue = getMetricValue(datum, metric);
          const secondaryValue = secondaryMetric ?
          getMetricValue(datum, secondaryMetric) :
          metricValue;
          const item = {
            name,
            value: metricValue,
            secondaryValue,
            groupBy: curGroupBy
          };
          result.push(item);
        });
      } else {
        const children = treeBuilder(
          value,
          restGroupby,
          metric,
          secondaryMetric
        );
        const metricValue = children.reduce(
          (prev, cur) => prev + cur.value,
          0
        );
        const secondaryValue = secondaryMetric ?
        children.reduce(
          (prev, cur) => prev + cur.secondaryValue,
          0
        ) :
        metricValue;
        result.push({
          name,
          children,
          value: metricValue,
          secondaryValue,
          groupBy: curGroupBy
        });
      }
    },
    []
  );
};(function () {var reactHotLoader = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.default : undefined;if (!reactHotLoader) {return;}reactHotLoader.register(getMetricValue, "getMetricValue", "/Users/evan_1/GitHub/superset/superset-frontend/plugins/plugin-chart-echarts/src/utils/treeBuilder.ts");reactHotLoader.register(treeBuilder, "treeBuilder", "/Users/evan_1/GitHub/superset/superset-frontend/plugins/plugin-chart-echarts/src/utils/treeBuilder.ts");})();;(function () {var leaveModule = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.leaveModule : undefined;leaveModule && leaveModule(module);})();
//# sourceMappingURL=treeBuilder.js.map