/**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
import type { EChartsCoreOption } from 'echarts/core';
import { NumberFormatter } from '@superset-ui/core';
import { EchartsBubbleChartProps, EchartsBubbleFormData } from './types';
import { Refs } from '../types';
export declare function formatTooltip(params: any, xAxisLabel: string, yAxisLabel: string, sizeLabel: string, xAxisFormatter: NumberFormatter, yAxisFormatter: NumberFormatter, tooltipSizeFormatter: NumberFormatter): string;
export default function transformProps(chartProps: EchartsBubbleChartProps): {
    refs: Refs;
    height: number;
    width: number;
    echartOptions: EChartsCoreOption;
    onContextMenu: import("@superset-ui/core").HandlerFunction | undefined;
    setDataMask: import("@superset-ui/core").SetDataMaskHook;
    formData: EchartsBubbleFormData;
};
//# sourceMappingURL=transformProps.d.ts.map