import Echart from '../components/Echart';
export default function Histogram(props) {
    const { height, width, echartOptions, onFocusedSeries, onLegendStateChanged, refs, } = props;
    const eventHandlers = {
        legendselectchanged: payload => {
            onLegendStateChanged?.(payload.selected);
        },
        legendselectall: payload => {
            onLegendStateChanged?.(payload.selected);
        },
        legendinverseselect: payload => {
            onLegendStateChanged?.(payload.selected);
        },
        mouseout: () => {
            onFocusedSeries(undefined);
        },
        mouseover: params => {
            onFocusedSeries(params.seriesIndex);
        },
    };
    return (<Echart refs={refs} height={height} width={width} echartOptions={echartOptions} eventHandlers={eventHandlers}/>);
}
//# sourceMappingURL=Histogram.jsx.map