(function () {var enterModule = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.enterModule : undefined;enterModule && enterModule(module);})();var __signature__ = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.default.signature : function (a) {return a;}; /**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
import { useState, useEffect, useMemo, useCallback } from 'react';
import { styled } from '@superset-ui/core';
import {

  sharedControlComponents } from
'@superset-ui/chart-controls';
import { AreaChartStackControlOptions } from '../constants';import { jsx as _jsx } from "@emotion/react/jsx-runtime";

const { RadioButtonControl } = sharedControlComponents;

const ExtraControlsWrapper = styled.div`
  text-align: center;
`;

export function useExtraControl(




{
  formData,
  setControlValue



}) {
  const { stack, area } = formData;
  const [extraValue, setExtraValue] = useState(
  stack != null ? stack : undefined
  );

  useEffect(() => {
    setExtraValue(stack);
  }, [stack]);

  const extraControlsOptions = useMemo(() => {
    if (area) {
      return AreaChartStackControlOptions;
    }
    return [];
  }, [area]);

  const extraControlsHandler = useCallback(
    (value) => {
      if (area) {
        if (setControlValue) {
          setControlValue('stack', value);
          setExtraValue(value);
        }
      }
    },
    [area, setControlValue]
  );

  return {
    extraControlsOptions,
    extraControlsHandler,
    extraValue
  };
}__signature__(useExtraControl, "useState{[extraValue, setExtraValue](stack ?? undefined)}\nuseEffect{}\nuseMemo{extraControlsOptions}\nuseCallback{extraControlsHandler}");

export function ExtraControls(





{
  formData,
  setControlValue



}) {
  const { extraControlsOptions, extraControlsHandler, extraValue } =
  useExtraControl({
    formData,
    setControlValue
  });

  if (!formData.showExtraControls) {
    return null;
  }

  return (
    _jsx(ExtraControlsWrapper, { children:
      _jsx(RadioButtonControl, {
        options: extraControlsOptions,
        onChange: extraControlsHandler,
        value: extraValue }
      ) }
    ));

}__signature__(ExtraControls, "useExtraControl{{ extraControlsOptions, extraControlsHandler, extraValue }}", () => [useExtraControl]);;(function () {var reactHotLoader = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.default : undefined;if (!reactHotLoader) {return;}reactHotLoader.register(RadioButtonControl, "RadioButtonControl", "/Users/evan_1/GitHub/superset/superset-frontend/plugins/plugin-chart-echarts/src/components/ExtraControls.tsx");reactHotLoader.register(ExtraControlsWrapper, "ExtraControlsWrapper", "/Users/evan_1/GitHub/superset/superset-frontend/plugins/plugin-chart-echarts/src/components/ExtraControls.tsx");reactHotLoader.register(useExtraControl, "useExtraControl", "/Users/evan_1/GitHub/superset/superset-frontend/plugins/plugin-chart-echarts/src/components/ExtraControls.tsx");reactHotLoader.register(ExtraControls, "ExtraControls", "/Users/evan_1/GitHub/superset/superset-frontend/plugins/plugin-chart-echarts/src/components/ExtraControls.tsx");})();;(function () {var leaveModule = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.leaveModule : undefined;leaveModule && leaveModule(module);})();
//# sourceMappingURL=ExtraControls.js.map